package example;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.springframework.stereotype.Component;
import sun.misc.BASE64Encoder;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import javax.xml.transform.Result;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.*;

@Component
public class SSO {
    private static Cipher getCipher(int mode, byte[] key) throws Exception{
        Cipher cipher = Cipher.getInstance("DES/ECB/PKCS5Padding");

        SecretKeySpec secretKeySpec = new SecretKeySpec(key, "DES");
        cipher.init(mode, secretKeySpec);

        return cipher;
    }

    public DesModel encrypt(String oaid) throws Exception {
        Date tm = new Date();
        SimpleDateFormat format = new SimpleDateFormat("MMmmHHss");
        byte[] key = format.format(tm).getBytes("utf-8");
        Cipher cipher = getCipher(Cipher.ENCRYPT_MODE, key);
        byte[] encrypted = cipher.doFinal(oaid.getBytes());
        String base64Encode = new BASE64Encoder().encode(encrypted);

        DesModel model = new DesModel();
        model.setToken(base64Encode.replace("+", "%2B"));
        model.setTm(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(tm));

        return model;
    }
}
