package example.controllers;

import example.DesModel;
import example.SSO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;

import java.net.URLEncoder;

@Controller
public class HomeController {
    @Autowired
    SSO sso;

    @GetMapping(path = { "/index", "/" })
    public String index(Model model) throws Exception
    {
        String oaid = "10123208";
        //token会过期，建议每次进入前都取一下
        DesModel token = sso.encrypt(oaid);

        //http://localhost:5003替换成实际接口地址
        model.addAttribute("mainSrc", "http://office.bowintek.com:8051/app/main/index.html#!/sso?loginToken="
                + URLEncoder.encode(token.getToken(), "utf-8")
                + "&tm=" + URLEncoder.encode(token.getTm(), "utf-8")
                + "&re=" + URLEncoder.encode("/tabindex", "utf-8"));

        return "index";
    }
}
